/* Ogle - A video player
 * xmms front end
 * Copyright (C) 2003 Rossen Tchobanski <rosko@rosko.net>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#include <stdio.h>
#include <sys/msg.h>
#include <unistd.h>
#include <stdlib.h>

#include <ogle/dvdcontrol.h>

#include <sys/socket.h>
#include <sys/un.h>
#include <errno.h>

#include <xmms/plugin.h>
#include <xmms/configfile.h>
#include <xmms/xmmsctrl.h>
#include <xmms/util.h>

#include <gtk/gtk.h>

#include <sys/types.h>       
#include <sys/stat.h>        
#include <fcntl.h>

#define MAX_PID 65536


DVDNav_t *nav;
DVDLocation_t location;

char *dvd_path;
int msgqid;
float fspeed=1.0;

char volid[33];
int isStarted;
int isPaused;

void ogle_configure(void);
void ogle_file_info_box(char *filename);

static int Action(char *action);
static int get_mid();


extern InputPlugin *get_iplugin_info(void);



void ogle_init()
{
  isPaused = 0;
  isStarted = 0;

/*
 *   DVDPlayerRegionSelect((DVDNav_t*)navigator,region);
 *   DVDDefaultAudioLanguageSelect((DVDNav_t*)navigator,a_lcode);
 *   DVDDefaultMenuLanguageSelect((DVDNav_t*)navigator,m_lcode);
 *   DVDDefaultSubpictureLanguageSelect((DVDNav_t*)navigator,s_lcode);
 *   DVDParentalCountrySelect((DVDNav_t*)navigator,p_ccode);
 *   DVDParentalLevelSelect((DVDNav_t*)navigator,level);
 */

}



static void ogle_play(char *filename)
{
  DVDResult_t res;
  int i=0;
  int  status;

  if (! isStarted) {
    system("ogle -u cli &");

    // get message id
    while((msgqid=get_mid())<0) i++;

    if(msgqid !=-1) { // ignore sending data.
      sleep(1);
      res = DVDOpenNav(&nav, msgqid);
      if(res != DVD_E_Ok ) {
    	DVDPerror("DVDOpen:", res);
    	exit(1);
      }
    }

    sprintf(volid,"VolID");

    // get vol id								  
    if (DVDGetVolumeIdentifiers((DVDNav_t*)nav,0,&status,volid,NULL)==DVD_E_Ok){  
      if (status!=0) {  							  
    	get_iplugin_info()->set_info(volid,strlen(volid),0,0,2);
    	return; 		  
      } 									  
    }										  

    isStarted = 1;
  } else {
//    Action("Play");
  }

  return;
}

static void ogle_stop(void)
{
  int n;
  printf("ogle_stop\n");
  
  DVDStop((DVDNav_t*)nav);
  
  system("killall ogle_cli");
}



static int is_our_file(char *filename)
{
  gchar *ext;
 
  ext = strrchr(filename, '.');
  if (ext) {
    if (!strcasecmp(ext, ".dvd")) {
      return TRUE;
    }
  }
  return FALSE;
}

static void ogle_about(void)
{
  static GtkWidget *box;

  box = xmms_show_message(
    "About Ogle DVD player XMMS front end",	   
    "Copyright(C)2003 by Rossen Tchobanski\n"	   
    "\n" 					   
    "http://www.rosko.net/ogle",		   
    "Ok",					   
    FALSE, NULL, NULL); 			   
  gtk_signal_connect(GTK_OBJECT(box), "destroy",
    GTK_SIGNAL_FUNC(gtk_widget_destroyed), &box);
}

static void ogle_pause(short p)
{
printf("ogle_pause\n");
  if(isPaused) {
    DVDPauseOff(nav);
    isPaused = 0;
  } else {
    DVDPauseOn(nav);
    isPaused = 1;
  }
}

static int ogle_get_time(void)
{
  char info_text[80];

  DVDGetCurrentLocation((DVDNav_t*)nav,&location);

//printf("Title %d ",location.title);
//printf("Chapter %.2d ",location.ptt);

  sprintf(info_text,
    "%s - %d:%.2d:%.2d of %d:%.2d:%.2d - %gx", volid, 
    location.title_current.Hours,location.title_current.Minutes,location.title_current.Seconds,
    location.title_total.Hours,location.title_total.Minutes,location.title_total.Seconds,
    fspeed);

  get_iplugin_info()->set_info(info_text,strlen(info_text),0,0,2);
  
  return 300;
}

/*
 * static void ogle_get_volume(int *l, int *r)
 * {
 * printf("ogle_get_volume\n");
 * }
 * 
 * static void ogle_set_volume(int l, int r)
 * {
 * printf("ogle_set_volume\n");
 * }
 */

/*
 * static void ogle_get_song_info(char *filename, char **title, int *length)
 * {
 * }
 */


void ogle_seek(int time)
{
printf("ogle_seek: %d\n", time);
}

void ogle_configure(void)
{  
printf("ogle_configure\n");
}

void ogle_file_info_box(char *filename)
{
printf("ogle_file_info_box\n");
}



InputPlugin ogle_ip =
{
  NULL,
  NULL,
  "Ogle DVD player",
  ogle_init,
  ogle_about,
  ogle_configure,
  is_our_file,
  NULL,
  ogle_play,
  ogle_stop,
  ogle_pause,
  ogle_seek,
  NULL,
  ogle_get_time,
  NULL, //ogle_get_volume,
  NULL, //ogle_set_volume,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL, //ogle_get_song_info,
  ogle_file_info_box,
  NULL
};


InputPlugin *get_iplugin_info(void)
{
  return &ogle_ip;
}

/* varios misk funktions */

/*
 * static int Action(char *action)
 * {
 *   int n;
 *   action_mapping_t *actions = get_action_mappings();
 * 
 * 
 *   for(n = 0; actions[n].str != NULL; n++) {    
 *     if(!strcmp(actions[n].str, action)) {      
 *       if(actions[n].fun != NULL) {	       
 *   	actions[n].fun(NULL);		       
 *       } 				       
 *       continue;
 *     }
 *   }
 * 
 *   return 0; 					       
 * }
 */


static int get_mid()
{
  static char cmdbuf[64];
  char buf[32];
  int fd;
  ssize_t count;
  int mid; 

  int pid;

  for (pid=1; pid<MAX_PID; pid++) { 
    sprintf(buf,"/proc/%u/cmdline",pid);
    if( (( fd=open(buf,O_RDONLY) )) == -1) continue;
    count = read(fd, cmdbuf, sizeof(cmdbuf)-1);
    close(fd);
    if(count<1) continue;
    cmdbuf[count] = '\0';

    if(!isprint(cmdbuf[0])) continue;
    while(count--) if(!isprint(cmdbuf[count])) cmdbuf[count]=' ';

    if (!memcmp(cmdbuf,"ogle_cli",8)) { 
      sscanf(cmdbuf, "ogle_cli -m %d", &mid);	
      return mid;
    }
  }

  return (-1);
}

